img = imread('cameraman.tif');
img = double(img);

G = 256;
maxd = 5; % maximum distance

[nl,nc] = size(img);
k = 1;
cAcc = zeros(G,G,4*maxd);
for d = 1:maxd % distance

    deltaX = d; deltaY = 0; % 0
    c = zeros(G,G);
    for x = 1:nl-deltaX
        for y = 1:nc-deltaY
            i = img(x,y)+1;
            j = img(x+deltaX,y+deltaY)+1;
            c(i,j) = c(i,j)+1;
            c(j,i) = c(j,i)+1;
        end
    end
    cAcc(:,:,k) = c; k=k+1;

    deltaX = d; deltaY = d; % 45
    c = zeros(G,G);
    for x = 1:nl-deltaX
        for y = 1:nc-deltaY
            i = img(x,y)+1;
            j = img(x+deltaX,y+deltaY)+1;
            c(i,j) = c(i,j)+1;
            c(j,i) = c(j,i)+1;
        end
    end
    cAcc(:,:,k) = c; k=k+1;
    
    deltaX = 0; deltaY = d; % 90
    c = zeros(G,G);
    for x = 1:nl-deltaX
        for y = 1:nc-deltaY
            i = img(x,y)+1;
            j = img(x+deltaX,y+deltaY)+1;
            c(i,j) = c(i,j)+1;
            c(j,i) = c(j,i)+1;
        end
    end
    cAcc(:,:,k) = c; k=k+1;
    
    deltaX = -d; deltaY = d; % 0
    c = zeros(G,G);
    for x = 1-deltaX:nl
        for y = 1:nc-deltaY
            i = img(x,y)+1;
            j = img(x+deltaX,y+deltaY)+1;
            c(i,j) = c(i,j)+1;
            c(j,i) = c(j,i)+1;
        end
    end
    cAcc(:,:,k) = c; k=k+1;
    
end
%==========================================================================
desc = [];
for k = 1:size(cAcc,3);
    
    c = cAcc(:,:,k);
    c = c/sum(c(:));

    cx = zeros(1,G);
    for i = 1:G
        for j = 1:G
            cx(i) = cx(i) + c(i,j);
        end
    end
    
    cy = zeros(1,G);
    for j = 1:G
        for i = 1:G
            cy(j) = cy(j) + c(i,j);
        end
    end
    
    mux = 0;
    for i = 1:G
        mux = mux + i*cx(i);
    end
    
    muy = 0;
    for j = 1:G
        muy = muy + j*cy(j);
    end   
    
    sigmax = 0;
    for i = 1:G
        sigmax = sigmax + (i-mux)^2*cx(i);
    end
    sigmax = sqrt(sigmax);
    
    sigmay = 0;
    for j = 1:G
        sigmay = sigmay + (y-muy)^2*cy(j);
    end    
    sigmay = sqrt(sigmay);
    
    energy = sum(c(:).^2);
    
    entropy = sum(c(c~=0).*log(c(c~=0)));
    
    correlation = 0;
    for i = 1:G
        for j = 1:G
            correlation = correlation + ((i-mux)*(j-muy)*c(i,j)); 
        end
    end
    correlation = correlation/(sigmax*sigmay);
    
    IDM = 0;
    for i = 1:G
        for j = 1:G
            IDM = IDM + 1/(1 + (i-j)^2)*c(i,j);
        end
    end
    
    inertia = 0;
    for i = 1:G
        for j = 1:G
            inertia = inertia + (i-j)^2*c(i,j);
        end
    end
    
    desc = [desc energy entropy correlation IDM inertia];

end
%==========================================================================
plot(desc);