img = imread('text.png');
[nl,nc] = size(img);

r = 1;
SE = zeros(2*r+1,2*r+1); % structuring element is a disk with radius r
for i = 1:2*r+1
    for j = 1:2*r+1
        if ((i-r-1)^2 + (j-r-1)^2) <= r^2
            SE(i,j) = 1;
        end
    end
end

img_dilate = zeros(nl,nc)
img_erode = zeros(nl,nc);
for i = r+1:nl-r
    for j = r+1:nc-r
        if sum(sum(img(i-r:i+r,j-r:j+r) & SE))
            img_dilate(i,j) = 1;
        end
        if sum(sum(img(i-r:i+r,j-r:j+r) & SE)) == sum(SE(:))
            img_erode(i,j) = 1;
        end        
    end
end

subplot(2,2,1);
imshow(img);
subplot(2,2,2);
imshow(img_dilate);
subplot(2,2,3);
imshow(img_erode);